<html>
<head>
<title>OgreIteratorWrapper.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreIteratorWrapper.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreIteratorWrapper_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __Ogre_Iterator_Wrapper_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __Ogre_Iterator_Wrapper_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="keyword">namespace </span>Ogre{
<a name="l00033"></a>00033 
<a name="l00045"></a>00045 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> IteratorType, <span class="keyword">typename</span> ValType&gt;
<a name="l00046"></a><a class="code" href="classOgre_1_1IteratorWrapper.html">00046</a> <span class="keyword">class </span><a class="code" href="classOgre_1_1IteratorWrapper.html" title="Basefunctionality for IteratorWrappers.">IteratorWrapper</a>
<a name="l00047"></a>00047 {
<a name="l00048"></a>00048 
<a name="l00049"></a>00049     <span class="keyword">private</span>:
<a name="l00051"></a>00051         <a class="code" href="classOgre_1_1IteratorWrapper.html#aa63bf50be25f7ea8098d2b0866779b47" title="Private constructor since only the parameterised constructor should be used.">IteratorWrapper</a>();
<a name="l00052"></a>00052 
<a name="l00053"></a>00053     <span class="keyword">protected</span>:
<a name="l00054"></a><a class="code" href="classOgre_1_1IteratorWrapper.html#aecdc604f73f00133d4f934a94913b468">00054</a>         IteratorType <a class="code" href="classOgre_1_1IteratorWrapper.html#aecdc604f73f00133d4f934a94913b468">mBegin</a>;
<a name="l00055"></a><a class="code" href="classOgre_1_1IteratorWrapper.html#ab46be8c170cbc9046a81784b463534b9">00055</a>         IteratorType <a class="code" href="classOgre_1_1IteratorWrapper.html#ab46be8c170cbc9046a81784b463534b9">mCurrent</a>;
<a name="l00056"></a><a class="code" href="classOgre_1_1IteratorWrapper.html#ad6beeb6fcd8840f4fcb30b3363c3552d">00056</a>         IteratorType <a class="code" href="classOgre_1_1IteratorWrapper.html#ad6beeb6fcd8840f4fcb30b3363c3552d">mEnd</a>;
<a name="l00057"></a>00057     
<a name="l00058"></a>00058 
<a name="l00059"></a>00059     <span class="keyword">public</span>:
<a name="l00060"></a>00060     
<a name="l00062"></a><a class="code" href="classOgre_1_1IteratorWrapper.html#a72df6843478e277b8dde180081156b98">00062</a>         <span class="keyword">typedef</span> ValType <a class="code" href="classOgre_1_1IteratorWrapper.html#a72df6843478e277b8dde180081156b98" title="type you expect to get by funktions like peekNext(Value)">ValueType</a>;
<a name="l00064"></a><a class="code" href="classOgre_1_1IteratorWrapper.html#a72bb580445cd26d668677e159b692d4f">00064</a>         <span class="keyword">typedef</span> ValType* <a class="code" href="classOgre_1_1IteratorWrapper.html#a72bb580445cd26d668677e159b692d4f" title="type you expect to get by funktions like peekNext(Value)Ptr">PointerType</a>;
<a name="l00065"></a>00065 
<a name="l00073"></a><a class="code" href="classOgre_1_1IteratorWrapper.html#a22c1c22fab97253a922a190d2ace205e">00073</a>         <span class="keyword">typedef</span> IteratorType <a class="code" href="classOgre_1_1IteratorWrapper.html#a22c1c22fab97253a922a190d2ace205e" title="typedef to fulfill container interface">iterator</a>;
<a name="l00074"></a>00074         
<a name="l00082"></a><a class="code" href="classOgre_1_1IteratorWrapper.html#a704ce78ef948a2730b4774b4ba0cea69">00082</a>         <span class="keyword">typedef</span> IteratorType <a class="code" href="classOgre_1_1IteratorWrapper.html#a704ce78ef948a2730b4774b4ba0cea69" title="typedef to fulfill container interface">const_iterator</a>;
<a name="l00083"></a>00083         
<a name="l00084"></a>00084         
<a name="l00085"></a>00085         
<a name="l00086"></a>00086 
<a name="l00087"></a>00087         
<a name="l00092"></a><a class="code" href="classOgre_1_1IteratorWrapper.html#aae5af61f58bb7e21b76f6b44088d5ea8">00092</a>         <a class="code" href="classOgre_1_1IteratorWrapper.html#aa63bf50be25f7ea8098d2b0866779b47" title="Private constructor since only the parameterised constructor should be used.">IteratorWrapper</a> ( IteratorType start, IteratorType last )
<a name="l00093"></a>00093         : <a class="code" href="classOgre_1_1IteratorWrapper.html#aecdc604f73f00133d4f934a94913b468">mBegin</a>( start ), <a class="code" href="classOgre_1_1IteratorWrapper.html#ab46be8c170cbc9046a81784b463534b9">mCurrent</a> ( start ), <a class="code" href="classOgre_1_1IteratorWrapper.html#ad6beeb6fcd8840f4fcb30b3363c3552d">mEnd</a> ( last )
<a name="l00094"></a>00094         {
<a name="l00095"></a>00095         }
<a name="l00096"></a>00096 
<a name="l00097"></a>00097 
<a name="l00099"></a><a class="code" href="classOgre_1_1IteratorWrapper.html#a468ebc8ca34585ed3ef17a432ee22704">00099</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1IteratorWrapper.html#a468ebc8ca34585ed3ef17a432ee22704" title="Returns true if there are more items in the collection.">hasMoreElements</a> ( )<span class="keyword"> const</span>
<a name="l00100"></a>00100 <span class="keyword">        </span>{
<a name="l00101"></a>00101             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1IteratorWrapper.html#ab46be8c170cbc9046a81784b463534b9">mCurrent</a> != <a class="code" href="classOgre_1_1IteratorWrapper.html#ad6beeb6fcd8840f4fcb30b3363c3552d">mEnd</a>;
<a name="l00102"></a>00102         }
<a name="l00103"></a>00103 
<a name="l00104"></a>00104 
<a name="l00106"></a><a class="code" href="classOgre_1_1IteratorWrapper.html#aaf01f897bea391797dc2bb9fb8374a5f">00106</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1IteratorWrapper.html#aaf01f897bea391797dc2bb9fb8374a5f" title="Moves the iterator on one element.">moveNext</a> (  )
<a name="l00107"></a>00107         {
<a name="l00108"></a>00108             ++<a class="code" href="classOgre_1_1IteratorWrapper.html#ab46be8c170cbc9046a81784b463534b9">mCurrent</a>;
<a name="l00109"></a>00109         }
<a name="l00110"></a>00110 
<a name="l00112"></a><a class="code" href="classOgre_1_1IteratorWrapper.html#acfb61cec43a0da5ae1b7c6ee6274498d">00112</a>         <span class="keyword">const</span> IteratorType&amp; <a class="code" href="classOgre_1_1IteratorWrapper.html#acfb61cec43a0da5ae1b7c6ee6274498d" title="bookmark to the begin of the underlying collection">begin</a>() {<span class="keywordflow">return</span> <a class="code" href="classOgre_1_1IteratorWrapper.html#aecdc604f73f00133d4f934a94913b468">mBegin</a>;}
<a name="l00113"></a>00113         
<a name="l00114"></a>00114         
<a name="l00116"></a><a class="code" href="classOgre_1_1IteratorWrapper.html#ab2daa0557a06aebd61686b13c865b6c0">00116</a>         IteratorType&amp; <a class="code" href="classOgre_1_1IteratorWrapper.html#ab2daa0557a06aebd61686b13c865b6c0" title="full access to the current iterator">current</a>(){<span class="keywordflow">return</span> <a class="code" href="classOgre_1_1IteratorWrapper.html#ab46be8c170cbc9046a81784b463534b9">mCurrent</a>;}
<a name="l00117"></a>00117         
<a name="l00119"></a><a class="code" href="classOgre_1_1IteratorWrapper.html#a0fd0df9bbfe0fc16939600b37de81739">00119</a>         <span class="keyword">const</span> IteratorType&amp; <a class="code" href="classOgre_1_1IteratorWrapper.html#a0fd0df9bbfe0fc16939600b37de81739" title="bookmark to the end (one behind the last element) of the underlying collection">end</a>() {<span class="keywordflow">return</span> <a class="code" href="classOgre_1_1IteratorWrapper.html#ad6beeb6fcd8840f4fcb30b3363c3552d">mEnd</a>;}
<a name="l00120"></a>00120         
<a name="l00121"></a>00121 
<a name="l00122"></a>00122 };
<a name="l00123"></a>00123 
<a name="l00124"></a>00124 
<a name="l00125"></a>00125 
<a name="l00136"></a>00136 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> IteratorType&gt;
<a name="l00137"></a><a class="code" href="classOgre_1_1VectorIteratorWrapper.html">00137</a> <span class="keyword">class </span><a class="code" href="classOgre_1_1VectorIteratorWrapper.html" title="Prepiared IteratorWrapper for container like std::vector.">VectorIteratorWrapper</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1IteratorWrapper.html" title="Basefunctionality for IteratorWrappers.">IteratorWrapper</a>&lt;T, IteratorType, typename  T::value_type&gt;
<a name="l00138"></a>00138 {
<a name="l00139"></a>00139 
<a name="l00140"></a>00140     <span class="keyword">public</span>:
<a name="l00141"></a><a class="code" href="classOgre_1_1VectorIteratorWrapper.html#a11b7947af4d7de6c8a371a45b0c92a81">00141</a>         <span class="keyword">typedef</span> <span class="keyword">typename</span> <a class="code" href="classOgre_1_1IteratorWrapper.html#a72df6843478e277b8dde180081156b98" title="type you expect to get by funktions like peekNext(Value)">IteratorWrapper&lt;T, IteratorType, typename  T::value_type&gt;::ValueType</a> <a class="code" href="classOgre_1_1VectorIteratorWrapper.html#a11b7947af4d7de6c8a371a45b0c92a81" title="type you expect to get by funktions like peekNext(Value)">ValueType</a> ; 
<a name="l00142"></a><a class="code" href="classOgre_1_1VectorIteratorWrapper.html#a3889b6a2de089ec7cb7426cb142f85b5">00142</a>         <span class="keyword">typedef</span> <span class="keyword">typename</span> <a class="code" href="classOgre_1_1IteratorWrapper.html#a72bb580445cd26d668677e159b692d4f" title="type you expect to get by funktions like peekNext(Value)Ptr">IteratorWrapper&lt;T, IteratorType, typename  T::value_type&gt;::PointerType</a> <a class="code" href="classOgre_1_1VectorIteratorWrapper.html#a3889b6a2de089ec7cb7426cb142f85b5" title="type you expect to get by funktions like peekNext(Value)Ptr">PointerType</a> ;
<a name="l00143"></a>00143     
<a name="l00144"></a>00144 
<a name="l00153"></a><a class="code" href="classOgre_1_1VectorIteratorWrapper.html#a8fbf70ecca363365f245308dcef54f7f">00153</a>         <a class="code" href="classOgre_1_1VectorIteratorWrapper.html#a8fbf70ecca363365f245308dcef54f7f" title="c&#39;tor">VectorIteratorWrapper</a> ( IteratorType start, IteratorType last )
<a name="l00154"></a>00154         : <a class="code" href="classOgre_1_1IteratorWrapper.html" title="Basefunctionality for IteratorWrappers.">IteratorWrapper</a>&lt;T, IteratorType, typename T::value_type&gt;( start, last ) 
<a name="l00155"></a>00155         {
<a name="l00156"></a>00156         }
<a name="l00157"></a>00157 
<a name="l00158"></a>00158 
<a name="l00160"></a><a class="code" href="classOgre_1_1VectorIteratorWrapper.html#aa9fb7dc63c70c2065eea12083c2467fb">00160</a>         <a class="code" href="classOgre_1_1IteratorWrapper.html#a72df6843478e277b8dde180081156b98" title="type you expect to get by funktions like peekNext(Value)">ValueType</a> <a class="code" href="classOgre_1_1VectorIteratorWrapper.html#aa9fb7dc63c70c2065eea12083c2467fb" title="Returns the next(=current) element in the collection, without advancing to the next.">peekNext</a> (  )<span class="keyword"> const</span>
<a name="l00161"></a>00161 <span class="keyword">        </span>{
<a name="l00162"></a>00162             <span class="keywordflow">return</span> *(this-&gt;<a class="code" href="classOgre_1_1IteratorWrapper.html#ab46be8c170cbc9046a81784b463534b9">mCurrent</a>);
<a name="l00163"></a>00163         }
<a name="l00164"></a>00164 
<a name="l00166"></a><a class="code" href="classOgre_1_1VectorIteratorWrapper.html#aafbb3662aba1dc76c617ce52724f2c66">00166</a>         <a class="code" href="classOgre_1_1IteratorWrapper.html#a72bb580445cd26d668677e159b692d4f" title="type you expect to get by funktions like peekNext(Value)Ptr">PointerType</a> <a class="code" href="classOgre_1_1VectorIteratorWrapper.html#aafbb3662aba1dc76c617ce52724f2c66" title="Returns a pointer to the next(=current) element in the collection, without advancing to the next afte...">peekNextPtr</a> (  )<span class="keyword">  const</span>
<a name="l00167"></a>00167 <span class="keyword">        </span>{
<a name="l00168"></a>00168             <span class="keywordflow">return</span> &amp;(*(this-&gt;<a class="code" href="classOgre_1_1IteratorWrapper.html#ab46be8c170cbc9046a81784b463534b9">mCurrent</a>) );
<a name="l00169"></a>00169         }
<a name="l00170"></a>00170 
<a name="l00172"></a><a class="code" href="classOgre_1_1VectorIteratorWrapper.html#a2460c8adb6819235849de954db6a0f64">00172</a>         <a class="code" href="classOgre_1_1IteratorWrapper.html#a72df6843478e277b8dde180081156b98" title="type you expect to get by funktions like peekNext(Value)">ValueType</a> <a class="code" href="classOgre_1_1VectorIteratorWrapper.html#a2460c8adb6819235849de954db6a0f64" title="Returns the next(=current) value element in the collection, and advances to the next.">getNext</a> (  ) 
<a name="l00173"></a>00173         {
<a name="l00174"></a>00174             <span class="keywordflow">return</span> *(this-&gt;<a class="code" href="classOgre_1_1IteratorWrapper.html#ab46be8c170cbc9046a81784b463534b9">mCurrent</a>++);
<a name="l00175"></a>00175         }   
<a name="l00176"></a>00176 
<a name="l00177"></a>00177 };
<a name="l00178"></a>00178 
<a name="l00179"></a>00179 
<a name="l00187"></a>00187 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00188"></a><a class="code" href="classOgre_1_1VectorIterator.html">00188</a> <span class="keyword">class </span><a class="code" href="classOgre_1_1VectorIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying container.">VectorIterator</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1VectorIteratorWrapper.html" title="Prepiared IteratorWrapper for container like std::vector.">VectorIteratorWrapper</a>&lt;T,  typename T::iterator&gt;{
<a name="l00189"></a>00189     <span class="keyword">public</span>:
<a name="l00194"></a><a class="code" href="classOgre_1_1VectorIterator.html#a1265123adbabbeee876a2962eea8db41">00194</a>         <a class="code" href="classOgre_1_1VectorIterator.html#a1265123adbabbeee876a2962eea8db41" title="Constructor.">VectorIterator</a>( <span class="keyword">typename</span> T::iterator start, <span class="keyword">typename</span> T::iterator last )
<a name="l00195"></a>00195         : <a class="code" href="classOgre_1_1VectorIteratorWrapper.html" title="Prepiared IteratorWrapper for container like std::vector.">VectorIteratorWrapper</a>&lt;T,  typename T::<a class="code" href="classOgre_1_1IteratorWrapper.html#a22c1c22fab97253a922a190d2ace205e" title="typedef to fulfill container interface">iterator</a>&gt;(start , last )
<a name="l00196"></a>00196         {
<a name="l00197"></a>00197         }
<a name="l00198"></a>00198 
<a name="l00203"></a><a class="code" href="classOgre_1_1VectorIterator.html#ab2f1a9935f5bb1e67948f7de03223ca4">00203</a>         <span class="keyword">explicit</span> <a class="code" href="classOgre_1_1VectorIterator.html#a1265123adbabbeee876a2962eea8db41" title="Constructor.">VectorIterator</a>( T&amp; c )
<a name="l00204"></a>00204         : <a class="code" href="classOgre_1_1VectorIteratorWrapper.html" title="Prepiared IteratorWrapper for container like std::vector.">VectorIteratorWrapper</a>&lt;T,  typename T::<a class="code" href="classOgre_1_1IteratorWrapper.html#a22c1c22fab97253a922a190d2ace205e" title="typedef to fulfill container interface">iterator</a>&gt; ( c.<a class="code" href="classOgre_1_1IteratorWrapper.html#acfb61cec43a0da5ae1b7c6ee6274498d" title="bookmark to the begin of the underlying collection">begin</a>(), c.<a class="code" href="classOgre_1_1IteratorWrapper.html#a0fd0df9bbfe0fc16939600b37de81739" title="bookmark to the end (one behind the last element) of the underlying collection">end</a>() )
<a name="l00205"></a>00205         {
<a name="l00206"></a>00206         }
<a name="l00207"></a>00207         
<a name="l00208"></a>00208 };
<a name="l00209"></a>00209 
<a name="l00218"></a>00218 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00219"></a><a class="code" href="classOgre_1_1ConstVectorIterator.html">00219</a> <span class="keyword">class </span><a class="code" href="classOgre_1_1ConstVectorIterator.html" title="Concrete IteratorWrapper for const access to the underlying container.">ConstVectorIterator</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1VectorIteratorWrapper.html" title="Prepiared IteratorWrapper for container like std::vector.">VectorIteratorWrapper</a>&lt;T,  typename T::const_iterator&gt;{
<a name="l00220"></a>00220     <span class="keyword">public</span>:
<a name="l00225"></a><a class="code" href="classOgre_1_1ConstVectorIterator.html#ab3b47789235e17783c2c7926220dbced">00225</a>         <a class="code" href="classOgre_1_1ConstVectorIterator.html#ab3b47789235e17783c2c7926220dbced" title="Constructor.">ConstVectorIterator</a>( <span class="keyword">typename</span> T::const_iterator start, <span class="keyword">typename</span> T::const_iterator last )
<a name="l00226"></a>00226         : <a class="code" href="classOgre_1_1VectorIteratorWrapper.html" title="Prepiared IteratorWrapper for container like std::vector.">VectorIteratorWrapper</a>&lt;T,  typename T::<a class="code" href="classOgre_1_1IteratorWrapper.html#a704ce78ef948a2730b4774b4ba0cea69" title="typedef to fulfill container interface">const_iterator</a>&gt; (start , last )
<a name="l00227"></a>00227         {
<a name="l00228"></a>00228         }
<a name="l00229"></a>00229 
<a name="l00234"></a><a class="code" href="classOgre_1_1ConstVectorIterator.html#a261f81ccce80c89491f50a7d18ff1ef3">00234</a>         <span class="keyword">explicit</span> <a class="code" href="classOgre_1_1ConstVectorIterator.html#ab3b47789235e17783c2c7926220dbced" title="Constructor.">ConstVectorIterator</a> ( <span class="keyword">const</span> T&amp; c )
<a name="l00235"></a>00235          : <a class="code" href="classOgre_1_1VectorIteratorWrapper.html" title="Prepiared IteratorWrapper for container like std::vector.">VectorIteratorWrapper</a>&lt;T,  typename T::<a class="code" href="classOgre_1_1IteratorWrapper.html#a704ce78ef948a2730b4774b4ba0cea69" title="typedef to fulfill container interface">const_iterator</a>&gt; (c.<a class="code" href="classOgre_1_1IteratorWrapper.html#acfb61cec43a0da5ae1b7c6ee6274498d" title="bookmark to the begin of the underlying collection">begin</a>() , c.<a class="code" href="classOgre_1_1IteratorWrapper.html#a0fd0df9bbfe0fc16939600b37de81739" title="bookmark to the end (one behind the last element) of the underlying collection">end</a>() )
<a name="l00236"></a>00236         {
<a name="l00237"></a>00237         }
<a name="l00238"></a>00238 };
<a name="l00239"></a>00239 
<a name="l00240"></a>00240 
<a name="l00241"></a>00241 
<a name="l00242"></a>00242 
<a name="l00243"></a>00243 
<a name="l00254"></a>00254 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> IteratorType&gt;
<a name="l00255"></a><a class="code" href="classOgre_1_1MapIteratorWrapper.html">00255</a> <span class="keyword">class </span><a class="code" href="classOgre_1_1MapIteratorWrapper.html" title="Prepiared IteratorWrapper for key-value container.">MapIteratorWrapper</a>  : <span class="keyword">public</span> <a class="code" href="classOgre_1_1IteratorWrapper.html" title="Basefunctionality for IteratorWrappers.">IteratorWrapper</a>&lt;T, IteratorType, typename T::mapped_type&gt;
<a name="l00256"></a>00256 {
<a name="l00257"></a>00257 
<a name="l00258"></a>00258     <span class="keyword">public</span>:
<a name="l00260"></a><a class="code" href="classOgre_1_1MapIteratorWrapper.html#a64c1d671b06f5048b9c2b93d51bda810">00260</a>         <span class="keyword">typedef</span> <span class="keyword">typename</span> <a class="code" href="classOgre_1_1IteratorWrapper.html#a72df6843478e277b8dde180081156b98" title="type you expect to get by funktions like peekNext(Value)">IteratorWrapper&lt;T, IteratorType, typename  T::mapped_type&gt;::ValueType</a> <a class="code" href="classOgre_1_1MapIteratorWrapper.html#a64c1d671b06f5048b9c2b93d51bda810" title="redefined ValueType for a map/set">ValueType</a> ; 
<a name="l00262"></a><a class="code" href="classOgre_1_1MapIteratorWrapper.html#ae8c56194816a6ebc9fd8005ed8c8cdde">00262</a>         <span class="keyword">typedef</span> <span class="keyword">typename</span> <a class="code" href="classOgre_1_1IteratorWrapper.html#a72bb580445cd26d668677e159b692d4f" title="type you expect to get by funktions like peekNext(Value)Ptr">IteratorWrapper&lt;T, IteratorType, typename  T::mapped_type&gt;::PointerType</a> <a class="code" href="classOgre_1_1MapIteratorWrapper.html#ae8c56194816a6ebc9fd8005ed8c8cdde" title="redefined PointerType for a map/set">PointerType</a> ;  
<a name="l00263"></a>00263         
<a name="l00265"></a><a class="code" href="classOgre_1_1MapIteratorWrapper.html#a9853756cc9d465e44272d69643d2c5ed">00265</a>         <span class="keyword">typedef</span> <span class="keyword">typename</span> T::value_type <a class="code" href="classOgre_1_1MapIteratorWrapper.html#a9853756cc9d465e44272d69643d2c5ed" title="unused, just to make it clear that map/set::value_type is not a ValueType">PairType</a> ; 
<a name="l00267"></a><a class="code" href="classOgre_1_1MapIteratorWrapper.html#aba5a8ef400da4e0338f9b257727e9377">00267</a>         <span class="keyword">typedef</span> <span class="keyword">typename</span> T::key_type <a class="code" href="classOgre_1_1MapIteratorWrapper.html#aba5a8ef400da4e0338f9b257727e9377" title="type you expect to get by funktions like peekNextKey">KeyType</a>;
<a name="l00268"></a>00268         
<a name="l00273"></a><a class="code" href="classOgre_1_1MapIteratorWrapper.html#a3ae82a852790d4ccf429958639672765">00273</a>         <a class="code" href="classOgre_1_1MapIteratorWrapper.html#a3ae82a852790d4ccf429958639672765" title="Constructor.">MapIteratorWrapper</a> ( IteratorType start, IteratorType last )
<a name="l00274"></a>00274         : <a class="code" href="classOgre_1_1IteratorWrapper.html" title="Basefunctionality for IteratorWrappers.">IteratorWrapper</a>&lt;T, IteratorType, typename T::mapped_type&gt;( start, last ) 
<a name="l00275"></a>00275         {
<a name="l00276"></a>00276         }
<a name="l00277"></a>00277 
<a name="l00279"></a><a class="code" href="classOgre_1_1MapIteratorWrapper.html#a0d526f75afc53f81358876237927bf54">00279</a>         <a class="code" href="classOgre_1_1MapIteratorWrapper.html#aba5a8ef400da4e0338f9b257727e9377" title="type you expect to get by funktions like peekNextKey">KeyType</a> <a class="code" href="classOgre_1_1MapIteratorWrapper.html#a0d526f75afc53f81358876237927bf54" title="Returns the next(=current) key element in the collection, without advancing to the next...">peekNextKey</a>(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00280"></a>00280 <span class="keyword">        </span>{
<a name="l00281"></a>00281             <span class="keywordflow">return</span> this-&gt;<a class="code" href="classOgre_1_1IteratorWrapper.html#ab46be8c170cbc9046a81784b463534b9">mCurrent</a>-&gt;first;
<a name="l00282"></a>00282         }
<a name="l00283"></a>00283 
<a name="l00284"></a>00284 
<a name="l00286"></a><a class="code" href="classOgre_1_1MapIteratorWrapper.html#a2e53278aea844de2e45a0386596f4d7f">00286</a>         <a class="code" href="classOgre_1_1IteratorWrapper.html#a72df6843478e277b8dde180081156b98" title="type you expect to get by funktions like peekNext(Value)">ValueType</a> <a class="code" href="classOgre_1_1MapIteratorWrapper.html#a2e53278aea844de2e45a0386596f4d7f" title="Returns the next(=current) value element in the collection, without advancing to the next...">peekNextValue</a> (  )<span class="keyword"> const</span>
<a name="l00287"></a>00287 <span class="keyword">        </span>{
<a name="l00288"></a>00288             <span class="keywordflow">return</span> this-&gt;<a class="code" href="classOgre_1_1IteratorWrapper.html#ab46be8c170cbc9046a81784b463534b9">mCurrent</a>-&gt;second;
<a name="l00289"></a>00289         }
<a name="l00290"></a>00290 
<a name="l00291"></a>00291 
<a name="l00294"></a><a class="code" href="classOgre_1_1MapIteratorWrapper.html#a31d2cda085c2efe14df9fb16918027e9">00294</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1IteratorWrapper.html#a72bb580445cd26d668677e159b692d4f" title="type you expect to get by funktions like peekNext(Value)Ptr">PointerType</a> <a class="code" href="classOgre_1_1MapIteratorWrapper.html#a31d2cda085c2efe14df9fb16918027e9" title="Returns a pointer to the next/current value element in the collection, without advancing to the next ...">peekNextValuePtr</a> (  )<span class="keyword">  const</span>
<a name="l00295"></a>00295 <span class="keyword">        </span>{
<a name="l00296"></a>00296             <span class="keywordflow">return</span> &amp;(this-&gt;<a class="code" href="classOgre_1_1IteratorWrapper.html#ab46be8c170cbc9046a81784b463534b9">mCurrent</a>-&gt;second);
<a name="l00297"></a>00297         }
<a name="l00298"></a>00298 
<a name="l00299"></a>00299 
<a name="l00301"></a><a class="code" href="classOgre_1_1MapIteratorWrapper.html#a2bef2d340ae00274856261b3ad3dcdbc">00301</a>         <a class="code" href="classOgre_1_1IteratorWrapper.html#a72df6843478e277b8dde180081156b98" title="type you expect to get by funktions like peekNext(Value)">ValueType</a> <a class="code" href="classOgre_1_1MapIteratorWrapper.html#a2bef2d340ae00274856261b3ad3dcdbc" title="Returns the next(=current) value element in the collection, and advances to the next.">getNext</a>()
<a name="l00302"></a>00302         {
<a name="l00303"></a>00303             <span class="keywordflow">return</span> ((this-&gt;<a class="code" href="classOgre_1_1IteratorWrapper.html#ab46be8c170cbc9046a81784b463534b9">mCurrent</a>++)-&gt;second) ;
<a name="l00304"></a>00304         }   
<a name="l00305"></a>00305     
<a name="l00306"></a>00306 
<a name="l00307"></a>00307 };
<a name="l00308"></a>00308 
<a name="l00309"></a>00309 
<a name="l00310"></a>00310 
<a name="l00311"></a>00311 
<a name="l00320"></a>00320 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00321"></a><a class="code" href="classOgre_1_1MapIterator.html">00321</a> <span class="keyword">class </span><a class="code" href="classOgre_1_1MapIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying key-value container.">MapIterator</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1MapIteratorWrapper.html" title="Prepiared IteratorWrapper for key-value container.">MapIteratorWrapper</a>&lt;T,  typename T::iterator&gt;{
<a name="l00322"></a>00322     <span class="keyword">public</span>:
<a name="l00323"></a>00323     
<a name="l00328"></a><a class="code" href="classOgre_1_1MapIterator.html#a69f5d04fa24319d698b69da3da118d36">00328</a>         <a class="code" href="classOgre_1_1MapIterator.html#a69f5d04fa24319d698b69da3da118d36" title="Constructor.">MapIterator</a>( <span class="keyword">typename</span> T::iterator start, <span class="keyword">typename</span> T::iterator last )
<a name="l00329"></a>00329         : <a class="code" href="classOgre_1_1MapIteratorWrapper.html" title="Prepiared IteratorWrapper for key-value container.">MapIteratorWrapper</a>&lt;T,  typename T::<a class="code" href="classOgre_1_1IteratorWrapper.html#a22c1c22fab97253a922a190d2ace205e" title="typedef to fulfill container interface">iterator</a>&gt;(start , last )
<a name="l00330"></a>00330         {
<a name="l00331"></a>00331         }
<a name="l00332"></a>00332         
<a name="l00337"></a><a class="code" href="classOgre_1_1MapIterator.html#acae97fd0a5ae45d19b51ef4bd046d516">00337</a>         <span class="keyword">explicit</span> <a class="code" href="classOgre_1_1MapIterator.html#a69f5d04fa24319d698b69da3da118d36" title="Constructor.">MapIterator</a>( T&amp; c )
<a name="l00338"></a>00338         : <a class="code" href="classOgre_1_1MapIteratorWrapper.html" title="Prepiared IteratorWrapper for key-value container.">MapIteratorWrapper</a>&lt;T,  typename T::<a class="code" href="classOgre_1_1IteratorWrapper.html#a22c1c22fab97253a922a190d2ace205e" title="typedef to fulfill container interface">iterator</a>&gt; ( c.<a class="code" href="classOgre_1_1IteratorWrapper.html#acfb61cec43a0da5ae1b7c6ee6274498d" title="bookmark to the begin of the underlying collection">begin</a>(), c.<a class="code" href="classOgre_1_1IteratorWrapper.html#a0fd0df9bbfe0fc16939600b37de81739" title="bookmark to the end (one behind the last element) of the underlying collection">end</a>() )
<a name="l00339"></a>00339         {
<a name="l00340"></a>00340         }
<a name="l00341"></a>00341         
<a name="l00342"></a>00342 };
<a name="l00343"></a>00343 
<a name="l00344"></a>00344 
<a name="l00353"></a>00353 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00354"></a><a class="code" href="classOgre_1_1ConstMapIterator.html">00354</a> <span class="keyword">class </span><a class="code" href="classOgre_1_1ConstMapIterator.html" title="Concrete IteratorWrapper for const access to the underlying key-value container.">ConstMapIterator</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1MapIteratorWrapper.html" title="Prepiared IteratorWrapper for key-value container.">MapIteratorWrapper</a>&lt;T,  typename T::const_iterator&gt;{
<a name="l00355"></a>00355     <span class="keyword">public</span>:
<a name="l00356"></a>00356     
<a name="l00361"></a><a class="code" href="classOgre_1_1ConstMapIterator.html#a0a882375777baafc650b3cd4a0a08144">00361</a>         <a class="code" href="classOgre_1_1ConstMapIterator.html#a0a882375777baafc650b3cd4a0a08144" title="Constructor.">ConstMapIterator</a>( <span class="keyword">typename</span> T::const_iterator start, <span class="keyword">typename</span> T::const_iterator last )
<a name="l00362"></a>00362         : <a class="code" href="classOgre_1_1MapIteratorWrapper.html" title="Prepiared IteratorWrapper for key-value container.">MapIteratorWrapper</a>&lt;T,  typename T::<a class="code" href="classOgre_1_1IteratorWrapper.html#a704ce78ef948a2730b4774b4ba0cea69" title="typedef to fulfill container interface">const_iterator</a>&gt; (start , last )
<a name="l00363"></a>00363         {
<a name="l00364"></a>00364         }
<a name="l00365"></a>00365 
<a name="l00370"></a><a class="code" href="classOgre_1_1ConstMapIterator.html#abded82ac05c8d0d3e56c6651eff3cad8">00370</a>         <span class="keyword">explicit</span> <a class="code" href="classOgre_1_1ConstMapIterator.html#a0a882375777baafc650b3cd4a0a08144" title="Constructor.">ConstMapIterator</a> ( <span class="keyword">const</span> T&amp; c )
<a name="l00371"></a>00371          : <a class="code" href="classOgre_1_1MapIteratorWrapper.html" title="Prepiared IteratorWrapper for key-value container.">MapIteratorWrapper</a>&lt;T,  typename T::<a class="code" href="classOgre_1_1IteratorWrapper.html#a704ce78ef948a2730b4774b4ba0cea69" title="typedef to fulfill container interface">const_iterator</a>&gt; (c.<a class="code" href="classOgre_1_1IteratorWrapper.html#acfb61cec43a0da5ae1b7c6ee6274498d" title="bookmark to the begin of the underlying collection">begin</a>() , c.<a class="code" href="classOgre_1_1IteratorWrapper.html#a0fd0df9bbfe0fc16939600b37de81739" title="bookmark to the end (one behind the last element) of the underlying collection">end</a>() )
<a name="l00372"></a>00372         {
<a name="l00373"></a>00373         }
<a name="l00374"></a>00374 };
<a name="l00375"></a>00375 
<a name="l00376"></a>00376 
<a name="l00377"></a>00377 
<a name="l00378"></a>00378 
<a name="l00379"></a>00379 }
<a name="l00380"></a>00380 
<a name="l00381"></a>00381 
<a name="l00382"></a>00382 
<a name="l00383"></a>00383 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
